##jacknife lgics hmms
#feature extraction a.a. composition
import random
import numpy
import math
import argparse
import sys
import os, glob
from Bio.Align.Applications import ClustalwCommandline
from Bio import Seq
from Bio import SeqIO
from Bio import AlignIO
from Bio.SeqRecord import SeqRecord
from collections import defaultdict
import hmmProfile
import searchHmm
import cleanUp
# clustal_loc=r"/usr/bin/clustalw"

##
##Given a array of fasta formatted sequences (Bio.Seq) export multi fasta file
##
def writeArrayFastaToFile(array,outfile):
	handle = open(outfile, "w")
	SeqIO.write(array, handle, "fasta")
	handle.close()



##
##desc: given a class returns the number of tms
##return: int the number of tms
##
def lgicClassesForExtraction(className):
	classes = {}
	
	classes['5ht3']= 4
	classes['Glycine']= 4
	classes['Ionotropic']= 3
	classes['ZAC']= 4
	classes['IP3']= 6
	classes['Epithelial']= 2
	classes['GABAA']= 4
	classes['Acid']= 2
	classes['P2X']= 2
	classes['Nicotinic']= 4
	return classes[className]


##
##desc: fake count of tms per LGIC class f
##return: dict with   key:	LGIC class
##		  value: fake number of tms
##
def lgicClasses():
	classes = {}
	
	classes['5ht3']= 4
	classes['Glycine']= 4
	classes['Ionotropic']= 4
	classes['ZAC']= 4
	classes['IP3']= 6
	classes['Epithelial']= 4
	classes['GABAA']= 4
	classes['Acid']= 4
	classes['P2X']= 4
	classes['Nicotinic']= 4
	return classes


##
##desc: fix positive inside rule Segment start
##	given a posision in sequence
##return: integer --> fix position
##
def fixPirStart(pos):
	pirExt = pos - 5
	if pirExt < 0:
		return 0
	else:
		return pirExt
	##fix start
	
##
##desc: fix positive inside rule Segment end
##	given a posision in sequence
##return: integer --> fix position
##
def fixPirEnd(pos,plen):
	##fix end
	pirExt = pos + 5
	if pirExt > plen:
		return plen
	else:
		return pirExt
		

##desc:  extract tms of a record from uniprot flat file
##	check for positive inside rule and fix segments
##	append results to a file in fasta formats
##	
##input:	1) a record uniprot flatfile
##	2) a filename to append the tms in fasta format
##	3) ctype = value (+,-) used for finding the segments to apply
##		  Positive inside rule correction
##
##return : --
##
##
	
def transMembraneRegionsPerRecordPIR(record,outFile,ctype):
	tmCounts = 00
	#print record.seq
	out  = open(outFile,'a')
	plen= len(str(record.seq._data))
	print "protein Length"
	print plen
	#print "%s" % str(record.seq._data)
	#exit()
	print "%s" % record.id
	for x in record.features:
		if x.type == "TRANSMEM":
			tmCounts = tmCounts + 1
			if ctype == "+":
				#print (x.location._start.position,x.location._end.position)
				trStart = fixPirStart(x.location._start.position) #for programming array numbering
				trEnd = x.location._end.position	 #for programming array numbering
				transSeq = str(record.seq._data)[trStart:trEnd]
				print transSeq# str(record.seq._data)[x.location._start.position:x.location._end.position]
				transValue = ">%s|%d-%d|%d\n%s\n" % (record.id,trStart,trEnd,tmCounts,transSeq)
				out.write(transValue)
				ctype = '-'
			else:
				#print (x.location._start.position,x.location._end.position)
				trStart = x.location._start.position		 #for programming array numbering
				trEnd = fixPirEnd(x.location._end.position,plen)	 #for programming array numbering
				transSeq = str(record.seq._data)[trStart:trEnd]
				print transSeq#str(record.seq._data)[x.location._start.position:x.location._end.position]
				transValue = ">%s|%d-%d|%d\n%s\n" % (record.id,trStart,trEnd,tmCounts,transSeq)
				out.write(transValue)
				ctype = '+'
	
	print "%d \n" % tmCounts
	out.close()
	#dict["#TMs"] = int(tmCounts)
	#return dict
	
	

##desc:  extract tms of a record from uniprot flat file
##	append results to a file in fasta formats
##	
##input:	1) a record uniprot flatfile
##	2) a filename to append the tms in fasta format
##	3) ctype = value (+,-) used for finding the segments to apply
##		  Positive inside rule correction
##
##return : --
##
##	
def transMembraneRegionsPerRecord(record,outFile):
	tmCounts = 0
	#print record.seq
	out  = open(outFile,'a')
	
	print "%s" % record.id
	for x in record.features:
		if x.type == "TRANSMEM":
			tmCounts = tmCounts + 1
			print (x.location._start.position,x.location._end.position)
			trStart = x.location._start.position #for programming array numbering
			trEnd = x.location._end.position	 #for programming array numbering
			transSeq = str(record.seq._data)[x.location._start.position:x.location._end.position]
			print str(record.seq._data)[x.location._start.position:x.location._end.position]
			transValue = ">%s|%d-%d|%d\n%s\n" % (record.id,trStart,trEnd,tmCounts,transSeq)
			out.write(transValue)
	
	print "%d \n" % tmCounts
	out.close()

##
##input:	1)prt1 = array of proteins in swissprot format (WHOLE FLAT FILE) from
##  								a class
##	2)outfile = the file name which tms will be saved
##
##desc make hmmprofiles
##
def oneRun(prt1, outFile):
	#to onoma tis klasis
	outName = outFile.split(".")[-2]
	print outName
	nTMs = lgicClassesForExtraction(outName)
	#arxikopoihse arxeio me ola ta diamemranika kommat
	deleteOut = open(outFile,'w')
	deleteOut.close()
	
	#gia kathe proteini vres ola ta diamemvanika tmhma kai apothikeuseta
	#sto arxeio outFile
	#ta tmhmata einai se fasta morfi
	#me id tis morfis >AC|start-end|NumberOfTM
	#to start-end einai programmatistika valmeno (arithmish opws se ena array )
	#to NumberOfTM einai poio diamemvaniko tmhma
	#to NumberOfTM einai poio diamemvaniko tmhma
	for record in prt1:
		if   nTMs == 2:
			transMembraneRegionsPerRecordPIR(record,outFile,"+")
		elif nTMs == 3:
			transMembraneRegionsPerRecordPIR(record,outFile,"-")
		elif nTMs == 4:
			transMembraneRegionsPerRecordPIR(record,outFile,"-")
		elif nTMs == 6:
			transMembraneRegionsPerRecord(record,outFile)
		else:
			print "error"
	hh = open(outFile,'r')
	regions = list(SeqIO.parse(hh, "fasta"))
	hh.close()
	
	
	#dimiourgia dictionary pou pernei listes
	dict = defaultdict(list)
	
	#xwrise ta tmhmata analoga apo poio diame pathike
	for y in regions:
		print y.id.split("|")[-1]
		tmNumber = y.id.split("|")[-1]
		dict[tmNumber].append(y)
		
	#grapse tis listes me ta diamemranika ana sygkektimeno tmhma se diaforetiak arxeia
	otnames = []
	for z in dict.keys():
		print "TM number %d" % int(z)
		otname = "%s_%d.tms" % (outName,int(z))
		otnames.append(otname)
		writeArrayFastaToFile(dict[z],otname)
		for m in dict[z]:
			print m
	otnamesAln = []
	#dhmiourgise tis stoixiseis twn diamemvanikwn
	for kk in range(0,len(otnames)):
		print otnames[kk]
		otnameAln= "%saln" % otnames[kk]
		hmmProfile.alignClustal(otnames[kk],otnameAln)
		otnamesAln.append(otnameAln)
		
	#dhmiourgise to hmmp twn diamemranikwn
	for kk in range(0,len(otnamesAln)):
		print otnamesAln[kk]
		hmmProfile.convertClustalToFastaBEFOREHEMMER(otnamesAln[kk])
		hmmProfile.hmmProfileMake(otnamesAln[kk])
		

##
##input: filenane of set of proteins in uniprot flat file
##
##desc: run jacknife
##
##
##
def jacknife(pSetFilename):
	results = "results.rsl"
	rslHandler = open(results,'a')
	filename = pSetFilename.split(".")[0].split("/")[-1]
	print filename
	#exit()
	outFile = "%s.tms" % filename
	
	
	#diavase to arxeio me ola ta uniprot arxeia tis sigkekrimenis klasis
	handle = open(pSetFilename,'r')
	#ola ta arxeia .uniprot se lista
	pSet = list(SeqIO.parse(handle, "swiss"))
	handle.close()
	llen = len(pSet)
	TP = 0
	FN= 0
	
	##non ion channele
	TN_Non=0
	FP_Non=0
	
	#voltage gated Transmembrane
	TN_Vol=0
	FP_Vol=0
	
	#LGIC not in this category
	TN_LGIC_NTC=0
	FP_LGIC_NTC=0
	
	#uniprot KW:LGIC other
	TN_Other=0
	FP_Other=0
	
	tnValues = llen
	for y in range(0,llen):
		#print pSet
		testingRecord = pSet.pop()
		print "training:"
		print len(pSet)
		print "testing: %s \n" % testingRecord.id
		##make profile
		##...
		##...
		oneRun(pSet, outFile)
		##test profile testing record
		##..
		##..
		with open('test.tst','w') as tstHandler:
			tstOut = ">%s\n%s" % (testingRecord.id,testingRecord.seq)
			print tstOut
			tstHandler.write(tstOut)
		##COUNT TP FB	
		(tp,fn) = searchHmm.tpSetTesting("test.tst")
		TP +=tp
		FN += fn
		##COUNT TN FP FOR NON ION
		tn,fp = searchHmm.tnSetTesting("proteinsFiles/nonIonTraining.fasta",tnValues)
		TN_Non += tn
		FP_Non += fp
		##COUNT TN FP ION CHANNEL
		tn,fp = searchHmm.tnSetTesting("proteinsFiles/voltage.fasta",tnValues)
		TN_Vol += tn
		FP_Vol += fp
		##COUNT TN FP OTHER
		notInThisClassTest = "proteinsFiles/not%sallLGICS.fas" % filename
		tn,fp = searchHmm.tnSetTesting1(notInThisClassTest,tnValues)
		TN_LGIC_NTC += tn
		FP_LGIC_NTC += fp
		
		tn,fp = searchHmm.tnSetTesting("proteinsFiles/otherLGIC.fasta",96)
		TN_Other += tn
		FP_Other += fp
		pSet.insert(0,testingRecord)
		#print (TP,FN,TN,FP)
	rslHandler.write(filename)
	rslHandler.write("\n")
	##
	##EXPORT TOTAL MEASURMENT FOR NON ION
	out1 = "%s %s %s %s\n" % (TP,FN,TN_Non,FP_Non)
	print (out1)
	rslHandler.write(out1)
	##EXPORT TOTAL MEASURMENT FOR ION
	print (TP,FN,TN_Vol,FP_Vol)
	out2 = "%s %s %s %s\n" % (TP,FN,TN_Vol,FP_Vol)
	
	
	rslHandler.write(out2)
	##EXPORT TOTAL MEASURMENT FOR NOT THIS CLASS
	print (TP,FN,TN_LGIC_NTC-FN,FP_LGIC_NTC-TP)
	out3 = "%s %s %s %s\n" % (TP,FN,TN_LGIC_NTC,FP_LGIC_NTC)
	rslHandler.write(out3)
	#rslHandler.write("\n")
	print (TP,FN,TN_Other,FP_Other)
	out4 = "%s %s %s %s\n" % (TP,FN,TN_Other,FP_Other)
	rslHandler.write(out4)
	#rslHandler.write("\n")
	rslHandler.close()	




##--------------------------------------------|----------------|------------------------------------------------------------------
##--------------------------------------------|----------------|------------------------------------------------------------------
##--------------------------------------------|------MAIN------|------------------------------------------------------------------
##--------------------------------------------|----------------|------------------------------------------------------------------
##--------------------------------------------|----------------|------------------------------------------------------------------


##DONT DELETE
##UNCOMMEND TO CLEAN UP FOLDER IF SOMETHING GO WRONG
#cleanUp.clean()
#exit()
##reinitialize results file

#jacknife profiles
rslHandler = open("results.rsl",'w')
rslHandler.close()
for x in glob.glob("proteinsFiles/*.uniprot"):
	if "ZAC" not in x:
		print x
	#exit()
		#testFileName = "5ht3.uniprot"
		jacknife(x)
		cleanUp.clean()
		#exit()
	#exit()
