#accurance
import numpy
import math
import argparse
from collections import defaultdict

#TP = int(args.trueP)
#TN = int(args.trueN)
#FP = int(args.falseP)
#FN = int(args.falseN)
#23072	22441	5111	44832

def getMeasurementType(index):
	if index == 1:
		return "NonIon"
	elif index ==2:
		return "Voltage"
	elif index ==3:
		return "Not in this Class"
	else:
		return "Other"
		
		
def createTotalDict():
	#append list with TP,TN,FP,FN
	classes = defaultdict(list)
	
	#plist0 =[]
	#for k in glob.glob('*.hmm'):
		#c = k.split("_")[0]
		#plist0.append(c)
	#plist = list(set(plist0))
	#for zz in plist:
		#print "classes['%s']= 0 " % zz
	#
	classes[getMeasurementType(1)]= []
	classes[getMeasurementType(2)]= []
	classes[getMeasurementType(3)]= []
	classes[getMeasurementType(4)]= []
	
	return classes

def addTotalDict(gmtName,TP,TN,FP,FN):
	#append list with TP,TN,FP,FN
	classes = defaultdict(list)
	
	#plist0 =[]
	#for k in glob.glob('*.hmm'):
		#c = k.split("_")[0]
		#plist0.append(c)
	#plist = list(set(plist0))
	#for zz in plist:
		#print "classes['%s']= 0 " % zz
	#
	classes[getMeasurementType(1)]= []
	classes[getMeasurementType(2)]= []
	classes[getMeasurementType(3)]= []
	classes[getMeasurementType(4)]= []
	
	return classes

	
def calcAcc (gmtName,TP,TN,FP,FN):
	#exit()
	#Sensitivity
	TPR= (float(TP)/(float(TP) + float(FN)))
	# Specificity
	SPC= (float(TN)/(float(TN) + float(FP)))
	# Accuracy
	ACC = ((float(TP) + float(TN))/(float(TP) + float(FP) + float(TN) + float(FN)))
	# Balanced_Accuracy
	B_ACC = (TPR + SPC)/2
	# MCC
	MCC = ((float(TP)*float(TN) - float(FP)*float(FN))/numpy.sqrt((float(TP) + float(FP)) * (float(TP) + float(FN)) * (float(TN) + float(FP)) * (float(TN) + float(FN))))
	
	#
	#print "True  Positive %s " % TP
	#print "True  Negative %s " % TN
	#print "False positive %s " % FP
	#print "False Negative %s " % FN
	#print "TOTAL          %s " % (TP + TN + FP + FN)
	#print ""
	#print "True Positive Rate (Sensitivity): %s " % TPR
	#print "True Negative Rate (Specificity): %s " % SPC
	#print "Accuracy:                         %s " % ACC
	#print "Balanced_Accuracy:                %s " % B_ACC
	#print "MCC:                              %s " % MCC
	
	print "%s,%d,%d,%d,%d,%3.2f,%3.2f,%3.2f,%3.2f,%3.2f" % (gmtName,TP,TN,FP,FN,TPR*100,SPC*100,ACC*100,B_ACC*100,MCC*100)
	
with open("results.rsl",'r') as rs:
	listR = rs.readlines()
	Cname = ""
	counter=0
	totalPerType = createTotalDict()
	for x in listR:
		#print len(x.split())
		words = x.split()
		
		if len(words) == 1:
			#print x
			Cname = x
			print "\n%s,%s,%s,%s,%s,%s,%s,%s,%s,%s" % (Cname.strip(),"TP","TN","FP","FN","TPR","SPC","ACC","B_ACC","MCC")
			counter =1
			if "ZAC" in x:
				break
		else:
			for y in range(0,len(words)):
				if int(words[y]) < 0:
					words[y] = 0
			#if counter  == 3
			if counter == 13:
				counter +=1
				continue
			else:	
				totalPerType[getMeasurementType(counter)].append([int(words[0]),int(words[2]),int(words[3]),int(words[1])])
				calcAcc(getMeasurementType(counter),int(words[0]),int(words[2]),int(words[3]),int(words[1]))
			counter += 1
			
			
	
	print "\n\n\nTOTAL,%s,%s,%s,%s,%s,%s,%s,%s,%s"  % ("TP","TN","FP","FN","TPR","SPC","ACC","B_ACC","MCC")	
	for x in totalPerType:
		if x in "Not in this Class":
			continue
		else:
			TPa = 0
			TNa = 0
			FPa = 0
			FNa = 0
			for y in totalPerType[x]:
				#print y
				TPa += y[0]
				TNa += y[1]
				FPa += y[2]
				FNa += y[3]
			calcAcc(x,TPa,TNa,FPa,FNa)
