#
import os, glob, sys, subprocess
import shutil
import random
import numpy
import math
import argparse
from Bio.Align.Applications import ClustalwCommandline
from Bio import Seq
from Bio import SeqIO
import getBestScore
from collections import defaultdict

def lgicClasses():
	classes = {}
	#plist0 =[]
	#for k in glob.glob('*.hmm'):
		#c = k.split("_")[0]
		#plist0.append(c)
	#plist = list(set(plist0))
	#for zz in plist:
		#print "classes['%s']= 0 " % zz
	#
	classes['5ht3']= 4
	classes['Glycine']= 4
	classes['Ionotropic']= 4
	classes['ZAC']= 4
	classes['IP3']= 6
	classes['Epithelial']= 4
	classes['GABAA']= 4
	classes['Acid']= 4
	classes['P2X']= 4
	classes['Nicotinic']= 4
	return classes


def lgicClassesScores():
	classes = {}
	#plist0 =[]
	#for k in glob.glob('*.hmm'):
		#c = k.split("_")[0]
		#plist0.append(c)
	#plist = list(set(plist0))
	#for zz in plist:
		#print "classes['%s']= 0 " % zz
	#
	classes['5ht3']= 0
	classes['Glycine']= 0
	classes['Ionotropic']= 0
	classes['ZAC']= 0
	classes['IP3']= 0
	classes['Epithelial']= 0
	classes['GABAA']= 0
	classes['Acid']= 0
	classes['P2X']= 0
	classes['Nicotinic']= 0
	return classes	



def lgicClassesThresholds():
	classes = {}
	
	classes['5ht3']= 20
	classes['Glycine']= 35
	classes['Ionotropic']= 20
	classes['ZAC']= 20
	classes['IP3']= 20
	classes['Epithelial']= 20
	classes['GABAA']= 35
	classes['Acid']= 20
	classes['P2X']= 20
	classes['Nicotinic']= 25
	return classes	
	
	
def ptoteinToFasta(prtn,file):
	outfile = file
	handle = open(outfile, "w")
	SeqIO.write(prtn, handle, "fasta")
	handle.close()

def countSameProfile(pList):
	#print ""
	#isLGIC = False
	lClasses = lgicClasses()
	pdict = defaultdict(list)
	for k in pList:
		c = k.split("_")[0]
		pdict[c].append(k)
	for x in pdict.keys():
		if len(pdict[x]) >= int(lClasses[x])/2:
			for x in pdict[x]:
				print x
			print ""
			return True
		else:
			continue
	return False

	#for k in glob.glob('*.hmm'):
	#dimiourgia dictionary pou pernei listes
	#dict = defaultdict(list)
	
	#xwrise ta tmhmata analoga apo poio diame pathike
	#for y in regions:
		#print y.id.split("|")[-1]
		#tmNumber = y.id.split("|")[-1]


		#dict[tmNumber].append(y)



##
###FOR TeStinG Calculate score
###
##
def countSameProfileScore(pList):
	#print ""
	#isLGIC = False
	lClasses = lgicClasses()
	lScores = lgicClassesScores()
	lThresholds = lgicClassesThresholds()
	pdict = defaultdict(list)
	for k in pList:
		c = k[0].split("_")[0]
		
		pdict[c].append(k[0])
		if float(k[1]) > lThresholds[c]:
			lScores[c] += float(k[1])
	maxNameScore = ["null",-1000]
	for x in pdict.keys():
		#maxNameScore = [x.split("_")[0]],lScores[x.split("_")[0]]]
		if len(pdict[x]) >= int(lClasses[x])/2:
			if lScores[x.split("_")[0]] > maxNameScore[1]:
				maxNameScore = [x.split("_")[0],lScores[x.split("_")[0]]]
			#for x in pdict[x]:
				#print (x,lScores[x.split("_")[0]])
			print ""
			#return True
		else:
			continue
	if maxNameScore[0] not in "null":
		print "Max profiles %s  , score:%s" % (maxNameScore[0],maxNameScore[1])
		if maxNameScore[1] > 30:
			return True
		else:
			return False
	else:
		return False







def tnSetTesting(infile,rV):
	TN = 0
	FP = 0
	hhl = open(infile,'r')
	ptr1 = list(SeqIO.parse(hhl, "fasta"))
	randomValues = rV
	if randomValues > len(ptr1):
		randomValues = len(ptr1)
	hhl.close()
	random.shuffle(ptr1,random.random)
	#randomValues= 20
	for l in range(0,randomValues):
		
		ptoteinToFasta(ptr1[l],"testing.fasta")
		
		tmRegionHmm = []
		for k in glob.glob('*.hmm'):
			#print k		
			#command = "hmmsearch --F3 0.001 %s %s > out.txt" % (k,"testing.fasta")
			command = "hmmsearch  %s %s > out.txt" % (k,"testing.fasta")
			os.system(command)
			hh = open("out.txt",'r')
			if "No hits detected" not in hh.read():
				#print "ok %s" % k.split(".")[-2]
				tmRegionHmm.append(k.split(".")[-2])
			hh.close()
		#print len(tmRegionHmm)
		
		if countSameProfile(tmRegionHmm):
			FP = FP + 1
			print ptr1[l].id
			for zz in tmRegionHmm:
				print zz
			print ""
		else:
			TN = TN + 1
		#shutil.move(k, "hmm/")
	print (TN,FP)
	return (TN,FP)


def tnSetTesting1(infile,rV):
	TN = 0
	FP = 0
	hhl = open(infile,'r')
	ptr1 = list(SeqIO.parse(hhl, "fasta"))
	randomValues = rV
	fpList =[]
	if randomValues > len(ptr1):
		randomValues = len(ptr1)
	hhl.close()
	random.shuffle(ptr1,random.random)
	#randomValues= 20
	for l in range(0,randomValues):
		
		ptoteinToFasta(ptr1[l],"testing.fasta")
		
		tmRegionHmm = []
		for k in glob.glob('*.hmm'):
			#print k		
			#command = "hmmsearch --F3 0.001 %s %s > out.txt" % (k,"testing.fasta")
			command = "hmmsearch  %s %s > out.txt" % (k,"testing.fasta")
			os.system(command)
			hh = open("out.txt",'r')
			if "No hits detected" not in hh.read():
				#print "ok %s" % k.split(".")[-2]
				hh.seek(0)
				bsProf=  getBestScore.getBestScore(hh)
				tmRegionHmm.append([k.split(".")[-2].split("/")[-1],bsProf])
			hh.close()
		#print len(tmRegionHmm)
		if countSameProfileScore(tmRegionHmm):
			FP = FP + 1
			fpList.append(ptr1[l])
		else:
			TN = TN + 1
			#fnList.append(l)
			print (ptr1[l].id,len(tmRegionHmm),len(ptr1[l].seq))
			print ptr1[l].id
			for zz in tmRegionHmm:
				print zz
			print ""
		#shutil.move(k, "hmm/")
	outFileFP = ""
	for z in glob.glob('*.hmm'):
		outFileFP = "fp/%s.out" % z
	handleFP = open(outFileFP,'w')
	SeqIO.write(fpList, handleFP, "fasta")
	print (TN,FP)
	return (TN,FP)
	
def tpSetTesting(infile):
	TP = 0
	FN = 0
	hhl = open(infile,'r')
	ptr1 = list(SeqIO.parse(hhl, "fasta"))
	hhl.close()
	fnList = []
	for l in ptr1:
		#ptoteinToFasta(l,"testing.fasta")
		#print l.id
		tmRegionHmm = []
		for k in glob.glob('*.hmm'):
			#print k		
			#command = "hmmsearch --F3 0.001 %s %s > out.txt" % (k,"test.tst")
			command = "hmmsearch %s %s > out.txt" % (k,"test.tst")
			os.system(command)
			hh = open("out.txt",'r')
			if "No hits detected" not in hh.read():
				#print "ok %s" % k.split(".")[-2]
				tmRegionHmm.append(k.split(".")[-2])
			hh.close()
		#print len(tmRegionHmm)
		#for kala in tmRegionHmm:
			#print kala
			
		if countSameProfile(tmRegionHmm):
			TP = TP + 1
			
		else:
			FN = FN + 1
			fnList.append(l)
			print (l.id,len(tmRegionHmm),len(l.seq))
			print l.id
			for zz in tmRegionHmm:
				print zz
			print ""
		#shutil.move(k, "hmm/")
	handleFN = open("FNproteins.fasta",'w')
	SeqIO.write(fnList, handleFN, "fasta")
	print (TP,FN)
	return (TP,FN)
	
	
#lgicClasses()
#exit()

#TN,FP = tnSetTesting("nonIonTraining.fasta")


##uncomment this
#kk = open("eval",'w')
#TN,FP = tnSetTesting("voltage.fasta")

#value = "TN: %s\nFP: %s\n" % (TN,FP)
#kk.write(value)





#TP,FN = tpSetTesting("testingTP.fasta")
#TP,FN = tpSetTesting("PSION_ION_TRAINING.fasta")
#value = "TP: %s\nFn: %s\n" % (TP,FN)
#kk.write(value)
#
