#feature extraction a.a. composition
import random
import numpy
import math
import argparse
import sys
import os, glob
from Bio.Align.Applications import ClustalwCommandline
from Bio import Seq
from Bio import SeqIO
from Bio import AlignIO
from Bio.SeqRecord import SeqRecord
from collections import defaultdict
import hmmProfile
import cleanUp
# clustal_loc=r"/usr/bin/clustalw"

def writeArrayFastaToFile(array,outfile):
	handle = open(outfile, "w")
	SeqIO.write(array, handle, "fasta")
	handle.close()

def transMembraneRegionsPerRecord(record,outFile):
	tmCounts = 0
	#print record.seq
	out  = open(outFile,'a')
	
	print "%s" % record.id
	for x in record.features:
		if x.type == "TRANSMEM":
			tmCounts = tmCounts + 1
			print (x.location._start.position,x.location._end.position)
			trStart = x.location._start.position #for programming array numbering
			trEnd = x.location._end.position	 #for programming array numbering
			transSeq = str(record.seq._data)[x.location._start.position:x.location._end.position]
			print str(record.seq._data)[x.location._start.position:x.location._end.position]
			transValue = ">%s|%d-%d|%d\n%s\n" % (record.id,trStart,trEnd,tmCounts,transSeq)
			out.write(transValue)
	
	print "%d \n" % tmCounts
	out.close()
	#dict["#TMs"] = int(tmCounts)
	#return dict
	
	
def fixPirStart(pos):
	pirExt = pos - 5
	if pirExt < 0:
		return 0
	else:
		return pirExt
	##fix start
	
def fixPirEnd(pos,plen):
	##fix end
	pirExt = pos + 5
	if pirExt > plen:
		return plen
	else:
		return pirExt
	
	
def transMembraneRegionsPerRecordPIR(record,outFile):
	tmCounts = 0
	#print record.seq
	out  = open(outFile,'a')
	
	print "%s" % record.id
	for x in record.features:
		if x.type == "TRANSMEM":
			tmCounts = tmCounts + 1
			print (x.location._start.position,x.location._end.position)
			trStart = x.location._start.position #for programming array numbering
			trEnd = x.location._end.position	 #for programming array numbering
			transSeq = str(record.seq._data)[x.location._start.position:x.location._end.position]
			print str(record.seq._data)[x.location._start.position:x.location._end.position]
			transValue = ">%s|%d-%d|%d\n%s\n" % (record.id,trStart,trEnd,tmCounts,transSeq)
			out.write(transValue)
	
	print "%d \n" % tmCounts
	out.close()
	#dict["#TMs"] = int(tmCounts)
	#return dict
	
def mainRun(fileset, outFile):
	#to onoma tis klasis
	outName = outFile.split(".")[-2]
	print outName
	
	
	#diavase to arxeio me ola ta uniprot arxeia tis sigkekrimenis klasis
	handle = open(fileset,'r')
	#ola ta arxeia .uniprot se lista
	prt1 = list(SeqIO.parse(handle, "swiss"))
	handle.close()
	
	#arxikopoihse arxeio me ola ta diamemranika kommat
	deleteOut = open(outFile,'w')
	deleteOut.close()
	
	#gia kathe proteini vres ola ta diamemvanika tmhma kai apothikeuseta
	#sto arxeio outFile
	#ta tmhmata einai se fasta morfi
	#me id tis morfis >AC|start-end|NumberOfTM
	#to start-end einai programmatistika valmeno (arithmish opws se ena array )
	#to NumberOfTM einai poio diamemvaniko tmhma
	for record in prt1:
		if len(record) < 250:
			continue
		else:
			transMembraneRegionsPerRecord(record,outFile)
	
	hh = open(outFile,'r')
	regions = list(SeqIO.parse(hh, "fasta"))
	hh.close()
	
	
	#dimiourgia dictionary pou pernei listes
	dict = defaultdict(list)
	
	#xwrise ta tmhmata analoga apo poio diame pathike
	for y in regions:
		print y.id.split("|")[-1]
		tmNumber = y.id.split("|")[-1]
		dict[tmNumber].append(y)
		
	#grapse tis listes me ta diamemranika ana sygkektimeno tmhma se diaforetiak arxeia
	otnames = []
	for z in dict.keys():
		print "TM number %d" % int(z)
		otname = "%s_%d.tms" % (outName,int(z))
		otnames.append(otname)
		writeArrayFastaToFile(dict[z],otname)
		for m in dict[z]:
			print m
	otnamesAln = []
	#dhmiourgise tis stoixiseis twn diamemvanikwn
	for kk in range(0,len(otnames)):
		print otnames[kk]
		otnameAln= "%saln" % otnames[kk]
		hmmProfile.alignClustal(otnames[kk],otnameAln)
		otnamesAln.append(otnameAln)
		
	#dhmiourgise to hmmp twn diamemranikwn
	for kk in range(0,len(otnamesAln)):
		print otnamesAln[kk]
		hmmProfile.convertClustalToFastaBEFOREHEMMER(otnamesAln[kk])
		hmmProfile.hmmProfileMake(otnamesAln[kk])
		

for x in glob.glob('*.uniprot'):
	infile = x
	filename = x.split(".")[0]
	outfile = "%s.tms" % filename
	mainRun(infile,outfile)
	#break
cleanUp.clean()